﻿Partial Public Class Page
    Inherits UserControl
 Dim tabMarques() As Rectangle
 Dim PosPrec As Point
 Dim nMarqueEnDéplacement As Integer = -1 ' indique quelle marque est en cours de déplacement
    Public Sub New()
        InitializeComponent()
    End Sub
 Private Sub LayoutRoot_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
  tabMarques = New Rectangle(2) {}
  tabMarques(0) = M0
  tabMarques(1) = M1
  tabMarques(2) = M2
  For i As Integer = 0 To tabMarques.Length - 1
   AddHandler tabMarques(i).MouseLeftButtonDown, AddressOf Marque_MouseLeftButtonDown
   AddHandler tabMarques(i).MouseMove, AddressOf Marque_MouseMove
   AddHandler tabMarques(i).MouseLeftButtonUp, AddressOf Marque_MouseLeftButtonUp
  Next i
  DisplayParameters()
 End Sub
 Private Sub Marque_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseEventArgs)
  Dim r As Rectangle = TryCast(sender, Rectangle)
  If r IsNot Nothing Then
   Dim p As Point = e.GetPosition(Me)
   Dim s As String = r.Name.Substring(1)
   Dim nMarque As Integer = Int32.Parse(s)
   nMarqueEnDéplacement = nMarque
   PosPrec = p
   tabMarques(nMarque).CaptureMouse()
  End If
 End Sub
 Private Sub Marque_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
  Dim r As Rectangle = TryCast(sender, Rectangle)
  If r IsNot Nothing Then
   ' une de nos trois marques. Laquelle ?
   Dim s As String = r.Name.Substring(1)
   Dim nMarque As Integer = Int32.Parse(s)
   If nMarqueEnDéplacement = nMarque Then
    Dim deltaX, deltaY As Double
    Dim p As Point = e.GetPosition(Me)
    deltaX = p.X - PosPrec.X
    deltaY = p.Y - PosPrec.Y
    Dim X As Double = CDbl(tabMarques(nMarque).GetValue(Canvas.LeftProperty))
    Dim Y As Double = CDbl(tabMarques(nMarque).GetValue(Canvas.TopProperty))
    tabMarques(nMarque).SetValue(Canvas.LeftProperty, X + deltaX)
    tabMarques(nMarque).SetValue(Canvas.TopProperty, Y + deltaY)
    PosPrec = p
    ' créer la courbe de Bézier modifiée
    Figs.Segments.Clear()
    Dim qbs As New QuadraticBezierSegment()
    Dim tP(2) As Point
    For i As Integer = 0 To tP.Length - 1
     tP(i).X = CDbl(tabMarques(i).GetValue(Canvas.LeftProperty)) + 5
     tP(i).Y = CDbl(tabMarques(i).GetValue(Canvas.TopProperty)) + 5
    Next i
    qbs.Point1 = tP(1)
    qbs.Point2 = tP(2)
    Figs.StartPoint = tP(0)
    Figs.Segments.Add(qbs)
    DisplayParameters()
   End If
  End If
 End Sub

 Private Sub Marque_MouseLeftButtonUp(ByVal sender As Object, ByVal e As MouseEventArgs)
  Dim r As Rectangle = TryCast(sender, Rectangle)
  If r IsNot Nothing Then
   ' de quelle marque s'agit-il ? 
   Dim s As String = r.Name.Substring(1)
   Dim nMark As Integer = Int32.Parse(s)
   nMarqueEnDéplacement = -1
   tabMarques(nMark).ReleaseMouseCapture()
  End If
 End Sub

 Private Sub DisplayParameters()
  Dim tP(2) As Point
  For i As Integer = 0 To 2
   tP(i).X = CDbl(tabMarques(i).GetValue(Canvas.LeftProperty)) + 5
   tP(i).Y = CDbl(tabMarques(i).GetValue(Canvas.TopProperty)) + 5
  Next i
  tbStPt.Text = tP(0).X & " - " & tP(0).Y
  tbEndPt.Text = tP(2).X & " - " & tP(2).Y
  tbCtrlPt.Text = tP(1).X & " - " & tP(1).Y
 End Sub
End Class